%define 	pname ucspi-tcp
%define 	pversion 0.88
%define		bversion 208
%define 	rpmrelease iworx

%define		iworxdir /home/interworx

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define 	build_rht_90   0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_fdr_30   0
%define		build_fdr_40   0
%define		build_fdr_80   0
%define		build_fdr_90   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0
%define		build_rhe_4x   0
%define		build_rhe_5x   0
%define		build_rhe_6x   0
%define		build_rhe_7x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_fdr30: 	%{expand: %%define build_fdr_30   1}}
%{?_with_fdr40: 	%{expand: %%define build_fdr_40   1}}
%{?_with_fdr80: 	%{expand: %%define build_fdr_80   1}}
%{?_with_fdr90: 	%{expand: %%define build_fdr_90   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}
%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}
%{?_with_rhe5x: 	%{expand: %%define build_rhe_5x   1}}
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}
%{?_with_rhe7x: 	%{expand: %%define build_rhe_7x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

%ifarch x86_64
	%define optflags -pipe -m64
%else
	%define	optflags -pipe
%endif

# Distro Statements
%if %{build_rht_90}
%define		oscode rht90
%define 	ostype RedHat 9
Requires:	zlib
Requires:	zlib-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		oscode cos3x
%define 	ostype CentOS 3.x
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		oscode fdr10
%define 	ostype Fedora Core 1
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		oscode fdr20
%define 	ostype Fedora Core 2
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_30}
%define		oscode fdr30
%define 	ostype Fedora Core 3
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_40}
%define		oscode fdr40
%define 	ostype Fedora Core 4
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_80}
%define		oscode fdr80
%define 	ostype Fedora Core 8
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_90}
%define		oscode fdr90
%define 	ostype Fedora Core 9
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		oscode whb3x
%define 	ostype White Box 3.x
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		oscode rhe2x
%define 	ostype RedHat Enterprise 2.x
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		oscode rhe3x
%define 	ostype RedHat Enterprise 3.x
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_4x}
%define		oscode rhe4x
%define 	ostype RedHat Enterprise 4.x
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_5x}
%define		oscode rhe5x
%define 	ostype RedHat Enterprise 5.x
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_7x}
%define		oscode rhe7x
%define 	ostype RedHat Enterprise 7.x
BuildRequires:	zlib-devel
Requires:	zlib
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif
%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	tcpserver and tcpclient for building TCP client-server apps
Name:		%{pname}
Version:	%{pversion}
Release:	%{release}
License:	D. J. Bernstein

Group:		System/Servers
Source0:	ucspi-tcp-%{pversion}.tar.bz2
URL:		http://cr.yp.to/ucspi-tcp.html

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C
Packager:	    Paul Oehler <poehler@interworx.com>

Buildroot:	%{_tmppath}/%{name}-%{version}

Obsoletes:	ucspi-tcp-toaster

Source1:	ucspi-tcp-%{pversion}-man.tar.bz2
Patch0:		ucspi-tcp-toaster-04182004.patch.bz2
Patch1:		rblsmtpd-nodefaultrbl.patch
Patch2:     ucspi-tcp-0.88-ipv6.diff19.bz2

%description
tcpserver and tcpclient are easy-to-use command-line tools for building TCP
client-server applications. tcpserver waits for incoming connections  and, 
for each  connection, runs a program  of  your  choice.  Your  program  
receives  environment  variables showing the local and remote host names, 
IP addresses, and port numbers. tcpserver offers a concurrency  limit to  
protect  you from  running out of processes and memory.   When you  are 
handling 40 (by default) simultaneous connections, tcpserver smoothly defers 
acceptance of new connections. tcpserver   also   provides   TCP  access  
control   features,  similar  to tcp-wrappers/tcpd's hosts.allow but much 
faster.  It's access control rules are compiled into a  hashed format  with 
cdb,  so it  can easily  deal with thousands of different hosts. This package  
includes  a  recordio  tool  that  monitors all the input and output of a 
server. tcpclient makes a TCP connection and runs a program of your choice. 
It sets up the same environment variables as tcpserver. This package includes 
several sample clients built on top of tcpclient: who@, date@, finger@, http@, 
tcpcat, and mconnect. tcpserver  and tcpclient conform to  UCSPI, the UNIX 
Client-Server Program Interface, using the TCP protocol.  UCSPI  tools are  
available for several different networks.

%package        doc
Summary:        Ucspi-tcp Documentation
Group:          Documentation
Obsoletes:	ucspi-tcp-toaster-doc

%description    doc
Tcpserver documentation (man pages): it waits for  incoming connections and, 
for each connection, runs a program of your choice.   Your program receives 
environment variables showing the local and remote host names, IP addresses, 
and port numbers.

%prep

%define name ucspi-tcp
%setup -q -n ucspi-tcp-%{pversion}
%patch0 -p0
%patch1 -p1
%patch2 -p1

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file 
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 5

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

%build

[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}

# We have gcc written in a temp file
echo "`cat %{_tmppath}/%{name}-%{pversion}-gcc` %{ccflags}"    >conf-cc
echo "`cat %{_tmppath}/%{name}-%{pversion}-gcc` -s %{ldflags}" >conf-ld

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

echo "%{_prefix}" >conf-home

# Socket.lib FIX
echo "Fixing socket.lib"
perl -pi -e 's|`cat socket.lib`|-lnsl -lm -lz|g' $RPM_BUILD_DIR/%{name}-%{pversion}/Makefile

# GLIBC fix
echo "Fixing errno.h for new GLIBC"
echo "#include <errno.h>" >> error.h

make

%install

mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_mandir}/{man5,man8}
install -m 755 addcr argv0 date@ delcr finger@ fixcrio http@ mconnect \
  mconnect-io rblsmtpd recordio tcpcat tcpclient tcprules tcprulescheck \
  tcpserver who@ %{buildroot}%{_bindir}
cd $RPM_BUILD_DIR
tar xvfj %{SOURCE1}
cd ucspi-tcp-%{pversion}-man
install -m 644 *.5 %{buildroot}%{_mandir}/man5
install -m 644 *.8 %{buildroot}%{_mandir}/man8

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion}-man ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}-man

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: ucspi-tcp package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%files doc
%attr(0644,root,root) %{_mandir}/man5/tcp-qualify.5*
%attr(0644,root,root) %{_mandir}/man8/addcr.8*
%attr(0644,root,root) %{_mandir}/man8/argv0.8*
%attr(0644,root,root) %{_mandir}/man8/date@.8*
%attr(0644,root,root) %{_mandir}/man8/delcr.8*
%attr(0644,root,root) %{_mandir}/man8/finger@.8*
%attr(0644,root,root) %{_mandir}/man8/fixcrio.8*
%attr(0644,root,root) %{_mandir}/man8/http@.8*
%attr(0644,root,root) %{_mandir}/man8/mconnect.8*
%attr(0644,root,root) %{_mandir}/man8/rblsmtpd.8*
%attr(0644,root,root) %{_mandir}/man8/recordio.8*
%attr(0644,root,root) %{_mandir}/man8/tcpcat.8*
%attr(0644,root,root) %{_mandir}/man8/tcpclient.8*
%attr(0644,root,root) %{_mandir}/man8/tcprules.8*
%attr(0644,root,root) %{_mandir}/man8/tcprulescheck.8*
%attr(0644,root,root) %{_mandir}/man8/tcpserver.8*
%attr(0644,root,root) %{_mandir}/man8/who@.8*

%files

%defattr (-,root,root)
%attr(0644,root,root) %doc CHANGES README TODO VERSION
%attr(0755,root,root) %{_bindir}/addcr
%attr(0755,root,root) %{_bindir}/argv0 
%attr(0755,root,root) %{_bindir}/date@ 
%attr(0755,root,root) %{_bindir}/delcr 
%attr(0755,root,root) %{_bindir}/finger@ 
%attr(0755,root,root) %{_bindir}/fixcrio 
%attr(0755,root,root) %{_bindir}/http@ 
%attr(0755,root,root) %{_bindir}/mconnect
%attr(0755,root,root) %{_bindir}/mconnect-io 
%attr(0755,root,root) %{_bindir}/rblsmtpd 
%attr(0755,root,root) %{_bindir}/recordio 
%attr(0755,root,root) %{_bindir}/tcpcat 
%attr(0755,root,root) %{_bindir}/tcpclient 
%attr(0755,root,root) %{_bindir}/tcprules 
%attr(0755,root,root) %{_bindir}/tcprulescheck
%attr(0755,root,root) %{_bindir}/tcpserver 
%attr(0755,root,root) %{_bindir}/who@

%changelog
* Tue Aug 26 2014 Matt Parmelee <mparmelee@interworx.com>
- Updated for RHEL 7.x
* Tue May 22 2012 Paul Oehler <poehler@interworx.com>
- Removed dependency on libmysqlclient.
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Tue Sep 14 2010 Paul Oehler <poehler@interworx.com>
- Added ipv6 support
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Mon Jul 13 2009 Paul Oehler <poehler@interworx.com>
- added rblsmtpd-nodefaultrbl.patch
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- Added support for Fedora 8
* Tue Feb 08 2005 Chris Wells <clwells@nexcess.net>
- Added fdr30 / fdr40
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
